<?php

/*
   
   File : lib/ifmx.lib.php3
   $Author: chuck $
   $Revision: 1.1 $
   $Date: 1998/10/07 21:40:39 $
   
   IMP : Copywrite 1998 Charles J. Hagenbuch <chuck@osmos.ml.org>
   
   This code is under the GNU Public License
   See the file COPYING in this directory
*/


/* This file is (c) 1998 Juraj Bednar. Any comments to <bednar@isternet.sk> */

/* STATE : This file _MAY_ work, it has been completely untested... */

/* Settings - these may be different for different servers */

$imp_db        = 'imp';                /* the name of imp's db (may add @server
                                          name for another server, otherwise
                                          $INFORMIXSERVER will be used        */
$db_user       = 'nobody';             /* user to connect to the database as  */
$db_pass       = '';                   /* database password                   */
$pref_table    = 'preferences';        /* the name of the prefs table         */
$address_table = 'address';            /* the name of the address table       */


/* Table Structure for Informix version:
   
   Preferences Table:
    field:     type:      description:
    user       text       joe@doe.com format username
    sig        text       signature
    (possibly more to be added later)
 
   Address Table:
    field:     type:      description:
    user       text       joe@doe.com identifier of who this entry belongs to
    address    text       address@mail.server.com - the actual address
    nickname   text       any entered nickname - ie "bonnie".
    fullname   text       full name - "My Bonnie".
*/


/* Required Functions - funtions that are called by other files and therefore
 * must be present in all db.lib implementations
 */


function imp_get_signature ($user, $server) {
  global $imp_db, $db_server, $db_user, $pref_table, $db_port, $db_options, $db_tty;
  
  /* post: returns the signature for the database key $user@$server
           (a string), or false on failure.
  */
  
  if (!($db=ifx_pconnect ($imp_db, $db_user, $db_pass))) { return false; }
  if (!($result = ifx_query($db, "select sig from $pref_table where user='$user@$server'"))) { return false; }
  
  $row = ifx_fetch_row ($result, "NEXT");
  if ($row) return $row[0]; 
   else
    return false;
}


function imp_set_signature ($signature, $user, $server) {
  global $imp_db, $db_server, $db_user, $pref_table, $db_port, $db_options, $db_tty;
  
  /* post: sets the signature to $signature for the database key $user@$server
           returns true on success and false on failure
  */
  
  if (imp_get_signature($user, $server)) {
    $sql = "update $pref_table set sig='$signature' where user='$user@$server'";
  } else {
    $sql = "insert into $pref_table values ('$user@$server', '$signature')";
  }
  
  if (!($db=ifx_pconnect ($imp_db, $db_user, $db_pass))) { return false; }
  if (!($result = ifx_query($db, $sql))) { return false; }
  
  return true;
}


function imp_get_addresses ($user, $server) {
  global $imp_db, $db_server, $db_user, $pref_table, $db_port, $db_options, $db_tty, $address_table;
  
  /* post: returns a 2d array of addresses where each
           element is an array in which element 0 is the address,
	   element 1 is the nickname, and element 2 is the fullname.
	   it returns false on failure.
  */
  
  if (!($db=ifx_pconnect ($imp_db, $db_user, $db_pass))) { return false; }
  if (!($result = ifx_query($db, "select address, nickname, fullname from $address_table where user='$user@$server' order by nickname"))) { return false; }
  
  if (($rowcount = ifx_affected_row($rid))==0) { return false; }

  for ($i=0; $i<$rowcount; $i++)
  {
   $return[$i] = ifx_fetch_row ($result, "NEXT"); 
  } 

  return($return);
}


function imp_delete_address ($address, $user, $server) {
  global $imp_db, $db_server, $db_user, $pref_table, $db_port, $db_options, $address_table;
  
  /* post: deletes $address from the addressbook of $user@$server
           returns true on success and false on failure
  */
  
  if (!($db=ifx_pconnect ($imp_db, $db_user, $db_pass))) { return false; }
  if (!($result = ifx_query($db, "delete from $address_table where user='$user@$server' and address='$address'"))) { return false; }
  
  return true;
}


function imp_add_address ($address, $nickname, $fullname, $user, $server) {
  global $imp_db, $db_server, $db_user, $pref_table, $db_port, $db_options, $db_tty, $address_table;
  
  /* post: adds $address, $nickname, $fullname to the addressbook for $user@$server
           returns true on success and false on failure
  */
  
  if (!($db=ifx_pconnect ($imp_db, $db_user, $db_pass))) { return false; }
  if (!($result = ifx_query($db, "insert into $address_table values ('$user@$server', '$address', '$nickname', '$fullname')"))) { return false; }
  
  return true;
}


function imp_update_address ($old_address, $address, $nickname, $fullname, $user, $server) {
  global $imp_db, $db_server, $db_user, $pref_table, $db_port, $db_options, $address_table;
  
  /* post: changes the entry for $old_address to $address, $nickname, $fullname.
           returns true on success and false on failure
  */
  
  if (!($db=ifx_pconnect ($imp_db, $db_user, $db_pass))) { return false; }
  if (!($result = ifx_query($db, "update $address_table set address='$address', nickname='$nickname', fullname='$fullname' where user='$user@$server' and address='$old_address'"))) { return false; }
  
  return true;
}


/* Support Functions - functions which are only used by routines in this file,
 * and which therefore can change from implementation to implementation.
 */


/* end db.lib */

?>
